//***************************************************************************
//  Genetic Algorithm Viewer 1.0
//    26/5/2000
//
//  This program uses a GA to find a Biomorph Genome
//    Jean-Philippe Rennard May 2000
//    alife@rennard.org
//    http://www.rennard.org/alife
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package Gav;

import java.awt.*;
import java.awt.event.*;

/** Draw genome's bits */ 
public class CGenBitView extends JPView {

  public CGenBitView(Color c) {
    super(c);
  }

  /** Draw Genome Boxes */
  void DrawBitGenome(CBiomorph biom) {
    Color c=Color.white;
    String bitgen=biom.GetBitGenomeString(biom.BiomGenome);
    double d=(Width-1)/(double)CBiomorph.GeneBitLength;
    for(int i=0;i<CBiomorph.GeneBitLength;i++) {
      if((i)%(CBiomorph.GeneBitLength/CBiomorph.NbGene)!=0) {
        if (bitgen.charAt(i)=='1')
          GrBuff.setColor(Color.blue);
        else
          GrBuff.setColor(Color.black);
      }
      else {
        if (bitgen.charAt(i)=='1')
          GrBuff.setColor(Color.yellow);
        else
          GrBuff.setColor(Color.darkGray);
      }
      GrBuff.fillRect((int)(i*d)+1,0,(int)(i*d+d)-1,Height);
      GrBuff.setColor(Color.red);
      GrBuff.fillRect((int)(i*d+d),0,(int)(i*d+d)+1,Height);
    }
    repaint();
  }

} // CgenBitView