//***************************************************************************
//  Genetic Algorithm Viewer 1.0
//    26/5/2000
//
//  This program uses a GA to find a Biomorph Genome
//    Jean-Philippe Rennard May 2000
//    alife@rennard.org
//    http://www.rennard.org/alife
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package Gav;

import java.awt.*;
import java.awt.event.*;

/** Manages display of the genome */
public class CGenView extends JPView {

  public CGenView(Color c) {
    super(c);
  }

  /** Draw Genome Boxes */
  void DrawGenome(CBiomorph biom) {
    Color c=Color.white;
    double step=Width/biom.NbGene;
    for(int i=0;i<biom.NbGene;i++) {
      GrBuff.setColor(GetGeneColor(biom.GetGene(i+1)));
      GrBuff.fillRect((int)(step*i),0,(int)(step*(i+1)),Height);
      repaint();
    }
  }

  /** Creates a color according to a gene value */
  Color GetGeneColor(int valgene) {
    Color c;
    int valred=0;
    int valgreen=0;
    int valblue=0;

    if(valgene<0)
      valred=(0xF*Math.abs(valgene)) << 16;
    else
      valblue=(0xF*Math.abs(valgene));
    valgreen=((0xFF-(0xF*Math.abs(valgene))) << 8);
    c=new Color(valred+valgreen+valblue);
    return(c);
  }
}